#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

###############################################################################
#                                                                             #
#    TkAntivir Scheduler 1.51.01 - zeitgesteuertes Suche nach Viren           #
#    Copyright (C) 1999-2006 Sebastian Geiges                                 #
#                                                                             #
#    AntiVir ist ein registriertes Warenzeichen der Avira GmbH.               #
#                                                                             #
#    This program is free software; you can redistribute it and/or modify     #
#    it under the terms of the GNU General Public License as published by     #
#    the Free Software Foundation; either version 2 of the License, or        #
#    (at your option) any later version.                                      #
#                                                                             #
#    This program is distributed in the hope that it will be useful,          #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of           #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            #
#    GNU General Public License for more details.                             #
#                                                                             #
#    You should have received a copy of the GNU General Public License        #
#    along with this program; see the file COPYING.  If not, write to         #
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,         #
#    Boston, MA 02111-1307, USA.                                              #
#                                                                             #
###############################################################################

# globale Variablen fuer die Pfade
set path_to_antivir  "/usr/lib/AntiVir"
set new_path_to_antivir  $path_to_antivir
set path_to_tkantivir  "/usr/X11R6/lib/TkAntivir"
set new_path_to_tkantivir  $path_to_tkantivir
set path_log ""
set new_path_log  $path_log
set recur 0
set rec_type ""

# globale Variable fuer Ergebnisse von Dialogboxen 
set buttonpressed -1
set find_ok -1


#####################################################################
# Lesen der Voreinstellungen aus der datei ~/.avtkrc                #
#####################################################################
proc read_preferences {} {

global path_to_antivir
global path_to_tkantivir
global path_log
global avver
global new_avver
   
# nur versuchen die Datei zu oeffnen, wenn sie auch da ist, um
# laestige Fehlermeldungen zu verhindern
if { [file exists "~/.avtkrc"] > 0} {
   
   # Datei zum Lesen oeffnen  
   set File1 [open "~/.avtkrc" r]
      
   # Zeilenweise bis Dateiende lesen      
   while {[gets $File1 line] > 0} {

         # Formatierung entfernen
         set line [string trim $line]

         # Kommentare ignorieren    
         if {[string first "#" "$line"] == 0} continue; 

         # String fuer Pfad zu AntiVir lesen
         if {[string first "antivir" "$line"] == 0} {
            set path_to_antivir [string range $line 9 end]
            set path_to_antivir [string trim $path_to_antivir]
	 }
	   
	 # String fuer Pfad f. Log-Dateien lesen
         if {[string first "logpath" "$line"] == 0} {
            set path_log [string range $line 9 end]
            set path_log [string trim $path_log]
         }
         
	 # String fuer Pfad f. Log-Dateien lesen
         if {[string first "tkavpath" "$line"] == 0} {
            set path_to_tkantivir [string range $line 10 end]
            set path_to_tkantivir [string trim $path_to_tkantivir]
         }
	 
         # String fuer AntiVir-Version lesen
         if {[string first "avver" "$line"] == 0} {
           set avver [string range $line 7 end]
           set avver [string trim $avver]
         }
         
   }
      
   # Datei wieder schliessen
   close $File1

}

}

#####################################################################
# Loeschen eines at-Jobs                                            #
#####################################################################
proc do_delete {} {

global jobno
global buttonpressed
   
# Fenster erzeugen
catch { destroy .del }
toplevel .del -class Dialog
wm title .del "Job lschen"


# Dialogelemente im Fenster plazieren
frame .del.a
label .del.a.l -width 15 -text "Nummer des Jobs" \
               -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .del.a.e -width 3 \
               -relief sunken \
               -bd 2 \
               -textvariable jobno
pack .del.a.l .del.a.e -side left

# Buttonleiste
frame .del.button

button .del.button.ok -text "OK" \
                      -command "set buttonpressed 1" \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                        
button .del.button.cancel -text "Abbrechen" \
                          -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                          -command "set buttonpressed 0" 
                            
pack  .del.button.ok .del.button.cancel -side left

pack .del.a \
     .del.button -ipadx 2m

# Warten auf Button
tkwait variable buttonpressed

# wenn es der Ok-Button war, so wird der Job mit "atrm Job-Nr." geloescht
if {$buttonpressed == 1} {
   open "|atrm $jobno" r+
   destroy .del
} else {
   destroy .del
}
   
.out.text configure -state normal
.out.text insert 0.0 "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
update
          
.out.text insert 1.0 "-----------------------------------------------------\n"
.out.text insert 2.0 "| Job  | Datum    | Ausfhrungszeit und Status      |\n"
.out.text insert 3.0 "-----------------------------------------------------\n"

set command "|atq"
append command " 2> /dev/null"

set Pipe2 [open $command r+]
while {![eof $Pipe2]} {
      set buffer2 [read $Pipe2 1000]
      regsub -all "\b" $buffer2 "" buffer2
      .out.text insert 4.0 $buffer2
}
          
close $Pipe2
               
.out.text configure -state disabled
    
}
      
#####################################################################
# Job-Infos anzeigen                    			    #
#####################################################################
proc do_info {} {

global jobno
global infocommand
global buttonpressed
   
# Variable leeren
set jobno ""

# Fenster erzeugen
catch { destroy .info }
toplevel .info -class Dialog
wm title .info "Job-Informationen"


# Dialogelemente im Fenster plazieren
frame .info.a
label .info.a.l -width 15 -text "Nummer des Jobs" \
               -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .info.a.e -width 3 \
                -relief sunken \
                -bd 2 \
                -textvariable jobno
pack .info.a.l .info.a.e -side left

# Buttonleiste
frame .info.button

button .info.button.ok -text "OK" \
                      -command "set buttonpressed 1" \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                        
button .info.button.cancel -text "Abbrechen" \
                          -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                          -command "set buttonpressed 0" 
                            
pack  .info.button.ok .info.button.cancel -side left

pack .info.a \
     .info.button -ipadx 2m

# Warten auf Button
tkwait variable buttonpressed

if {$buttonpressed == 1} {

   destroy .info
   catch { destroy .win }
   toplevel .win -class Dialog
   wm title .win "Job-Informationen"
   wm resizable .win 1 1

   frame .win.output 

   text .win.output.text -relief sunken -bd 2 \
                         -yscrollcommand ".win.output.scroll set" -bg white
   scrollbar .win.output.scroll -command ".win.output.text yview"

   frame .win.buttons
   button .win.buttons.ok -text "Schlieen" -command "destroy .win" \
                          -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

   pack .win.output.scroll -side right -fill y
   pack .win.output.text 
   pack .win.output

   pack .win.buttons .win.buttons.ok

   set infocommand "|at -c $jobno 2>/dev/null"

   set Pipe2 [open $infocommand r+]

   while {![eof $Pipe2]} {
         set buffer2 [read $Pipe2 1000]
         regsub -all "\b" $buffer2 "" buffer2
         .win.output.text insert end $buffer2
   }

   close $Pipe2

   .win.output.text insert end "     ------------------------------------------------------------------\n"
   .win.output.text insert end "     | Bitte beachten Sie: Nur die 2-3 letzten Zeilen sind wichtig.   |\n"
   .win.output.text insert end "     ------------------------------------------------------------------\n\n"
   
   .win.output.text configure -state disabled
   
} else {
   destroy .info      
}

}

######################################################################
# Stellt auf wiederkehrende Termine um                               #
######################################################################
proc do_recur {} {

global recur

set recur 1

.time.today configure -text "tglich ausfhren"
.time.tomorrow configure -text "wchentl. ausfhren"
.time.indays.l configure -text "alle x Tage"
.end.button2 configure -text "    Einmalige Termine     " -command do_once
update

}

######################################################################
# Stellt auf einmalige Jobs um                                       #
######################################################################
proc do_once {} {

global recur

set recur 0

.time.today configure -text "heute ausfhren"
.time.tomorrow configure -text "morgen ausfhren   "
.time.indays.l configure -text "in x Tagen "
.end.button2 configure -text "Wiederkehrende Termine" -command do_recur

update

}

#####################################################################
# Engine - Erstellt aus den Optionen den at-Aufruf, fuehrt ihn aus  #
# und aktualisiert die Ausgabe                                      #
#####################################################################
proc do_plan {} {

# globale Optionen
global path_to_antivir
global subdir
global path_log
global path_to_search
global when
global indays
global time
global recur
global rec_type
global time_save
global time_save2
   
# Kommando zusammenstellen
set antivircommand $path_to_antivir
append antivircommand "/antivir "
append antivircommand $path_to_search
append antivircommand "/"
append antivircommand " -allfiles"
     
# Suchoption "auch Unterverzeichnisse" beruecksichtigen
if {$subdir == 1} {
   append antivircommand " -s"
}
      
# keinen symbolischen Links folgen
append antivircommand " -nolnk"
      
# Log-Aufruf/Pfad fuer Log-Datei
append antivircommand " -rf"
append antivircommand $path_log
append antivircommand "/avlinux.log -ro"

set atdate $time

if {$recur == 0} {

   if {[string compare "$when" "tomorrow"] == 0} {
      append atdate " tomorrow"
   }
      
   if {[string compare "$when" "indays"] == 0} {
      append atdate " + $indays days"
   }

} else {

set atdate2 $time

   if {[string compare "$when" "today"] == 0} {
      set rec_type "daily"
      append atdate2 " tomorrow"
   }

   if {[string compare "$when" "tomorrow"] == 0} {
      set rec_type "weekly"
      append atdate2 " + 7 days"
   }
  
   if {[string compare "$when" "indays"] == 0} {
      set rec_type "alldays"
      append atdate2 " + $indays days"
   }
   
}

# AV-Aufruf in Datei      
if {$recur == 0} {
   set File1 [open "$path_log/once.avsched" w]
}

if {$recur == 1} {
   set time_save [string range $time 0 1]
   set time_save [string trim $time_save]

   set time_save2 [string range $time 3 4]
   set time_save2 [string trim $time_save2]


   set File1 [open "$path_log/$time_save$time_save2$rec_type.avsched" w]
}

# Variable schreiben
puts $File1 "$antivircommand"
if {$recur == 1} {
   puts $File1 "at -m -f $path_log/$time_save$time_save2$rec_type.avsched $atdate2"
}
puts $File1 ""
if {$subdir == 1} {
    puts $File1 "# JOB-INFORMATIONEN: Durchsucht $path_to_search inkl. Unterverzeichnisse"
} else {
    puts $File1 "# JOB-INFORMATIONEN: Durchsucht $path_to_search excl. Unterverzeichnisse"
}
puts $File1 "# um $time Uhr."

if {$recur == 1} {
   if {[string compare "$rec_type" "daily"] == 0} {
      puts $File1 "# Dieser Job wird tglich ausgefhrt."
   }
   if {[string compare "$rec_type" "weekly"] == 0} {
      puts $File1 "# Dieser Job wird wchentlich ausgefhrt."
   }
   if {[string compare "$rec_type" "alldays"] == 0} {
      puts $File1 "# Dieser Job wird alle $indays Tage ausgefhrt."
   }

} else {
   puts $File1 "# Dieser Job wird einmalig ausgefhrt. Es ist kein wiederkehrender Job."
}

puts $File1 ""
   
# Datei wieder schliessen
close $File1

     
# at-Job eintragen
              	       
set command "|"
if {$recur == 1} {
append command "at -m -f $path_log/$time_save$time_save2$rec_type.avsched $atdate"
} else {
append command "at -m -f $path_log/once.avsched $atdate"
}
append command " 2> /dev/null"

open $command r+

# at-Status ausgeben und alten Status nach unten ins Unsichtbare verschieben               
.out.text configure -state normal
.out.text insert 0.0 "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
update
          
.out.text insert 1.0 "-----------------------------------------------------\n"
.out.text insert 2.0 "| Job  | Datum    | Ausfhrungszeit und Status      |\n"
.out.text insert 3.0 "-----------------------------------------------------\n"

after 300
set command "|atq"
append command " 2> /dev/null"

set Pipe2 [open $command r+]

while {![eof $Pipe2]} {
      set buffer2 [read $Pipe2 1000]
      regsub -all "\b" $buffer2 "" buffer2
      .out.text insert 4.0 $buffer2
}
          
close $Pipe2
               
.out.text configure -state disabled
               
}

#####################################################################
# at-Status erneut ausgeben - via F5                                #
#####################################################################
proc refresh {} {

.out.text configure -state normal

# at-Status ausgeben
.out.text insert 0.0 "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
update

.out.text insert 1.0 "-----------------------------------------------------\n"
.out.text insert 2.0 "| Job  | Datum    | Ausfhrungszeit und Status      |\n"
.out.text insert 3.0 "-----------------------------------------------------\n"

set command "|atq"
append command " 2> /dev/null"

set Pipe2 [open $command r+]

while {![eof $Pipe2]} {
      set buffer2 [read $Pipe2 1000]
      regsub -all "\b" $buffer2 "" buffer2
      .out.text insert 4.0 $buffer2
}
         
close $Pipe2
.out.text configure -state disabled

update

}

#####################################################################
# HAUPTPROGRAMM - T k A n t i v i r  S c h e d u l e r  1 . 5 1 .01 #
#####################################################################
read_preferences

# ###################################################################
# Layout des Fensters
#
frame .menu -relief raised -bd 2
frame .links
frame .rechts
frame .nochrechter
frame .oben
frame .mitte
frame .unten


# ###################################################################
# Elemente der linken Seite

frame .suchen -relief groove -bd 2 

label .suchen.titel -text "TkAntivir Starteinstellungen"
                               
checkbutton .suchen.subdir -text "auch Unterverzeichnisse" \
                           -variable subdir -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                               
frame .suchen.pfad
label .suchen.pfad.l  -text "Pfad" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .suchen.pfad.e  -width 18 \
                      -relief sunken \
			             -bd 2 \
               			    -textvariable path_to_search -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                               
pack .suchen.pfad.l .suchen.pfad.e -side left


pack .suchen .suchen.titel .suchen.pfad .suchen.subdir -anchor nw


frame .end -relief groove -bd 2

label .end.titel -text "    " -font -*-Helvetica-Medium-R-Normal--*-10-*-*-*-*-*-*

button .end.button -text "   Scheduler schlieen   " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
		             -command exit -justify center
                   
button .end.button2 -text "Wiederkehrende Termine" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
         	          -command do_recur -justify center
                      
pack .end .end.titel .end.button2 .end.button -anchor center

# ###################################################################
# Elemente fuer Frame rechts
frame .time -relief groove -bd 2 
                  
label .time.titel     -text "Zeiteinstellungen"

frame .time.time2

label .time.time2.l -text "Uhrzeit" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .time.time2.e -width 12 \
                    -relief sunken \
	           		    -bd 2 \
             			    -textvariable time
pack .time.time2.l .time.time2.e -side left

radiobutton .time.today -text "heute ausfhren" \
                        -variable when -value today -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                        
radiobutton .time.tomorrow -text "morgen ausfhren   " \
                           -variable when -value tomorrow -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
frame .time.indays                                  
radiobutton .time.indays.l -text "in x Tagen " \
                           -variable when -value indays -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* 
entry .time.indays.e -width 5 \
                     -relief sunken \
	            		    -bd 2 \
              			    -textvariable indays
pack .time.indays.l .time.indays.e -side left

set when today

pack .time .time.titel .time.time2 .time.today .time.tomorrow .time.indays -anchor nw

frame .buttons -relief groove -bd 2 
                  
frame .buttons.but

label .buttons.titel     -text "Scheduler-Funktionen"

button .buttons.plan -text "  Eintragen   " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
		               -command do_plan

button .buttons.del -text  "   Lschen   " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
             		     -command do_delete

button .buttons.info -text "  Job-Infos  " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
             		     -command do_info

button .buttons.update -text "    Update    " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                		     -command refresh
		     
pack .buttons.but .buttons.titel .buttons.plan .buttons.del .buttons.info .buttons.update -anchor center
                 
pack .buttons .buttons.but -anchor nw


# ###################################################################
# Elemente fuer Frame unten
frame .out -relief flat -bd 2 
                  
text .out.text -relief sunken -bd 2 -bg white

pack .out .out.text

# Status-Leiste hinzufuegen
frame .statusBar
label .statusBar.big -text "TkAntivir Scheduler 1.51.01 - Copyright (C) 1999-2006 by Sebastian Geiges. Released under the GPL." -relief sunken -bd 1 \
                     -font -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-* -anchor w
label .statusBar.small -width 8 -relief sunken -bd 1 \
                       -font -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-* -anchor w
pack .statusBar.big -side left -padx 2 -expand yes -fill both
pack .statusBar.small -side left -padx 2

# ###################################################################
# jetzt den Layoutmananger anwerfen
wm title . "TkAntivir Scheduler"
wm resizable . 1 1

bind . <F5> {refresh}

pack .mitte
pack .links .rechts .nochrechter -side left -in .mitte -anchor nw
pack .unten
pack .suchen -in .links -fill x -ipadx 4m -padx 4m -pady 2m -ipady 0.7m
pack .end -anchor center -in .links -fill x -ipadx 4m -padx 4m -ipady 0.7m
pack .time -in .rechts -fill y -padx 3m -pady 2m -ipadx 4m -ipady 6m
pack .buttons -anchor nw -in .nochrechter -padx 4m -pady 2m -ipadx 4m -ipady 1.7m -side top
pack .out -fill y -anchor nw -in .unten 
pack .statusBar -side top -fill x -pady 2

# at-Status ausgeben

.out.text insert 0.0 "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n"
update idletask

.out.text insert 1.0 "-----------------------------------------------------\n"
.out.text insert 2.0 "| Job  | Datum    | Ausfhrungszeit und Status      |\n"
.out.text insert 3.0 "-----------------------------------------------------\n"

set command "|atq"
append command " 2> /dev/null"

set Pipe2 [open $command r+]

while {![eof $Pipe2]} {
      set buffer2 [read $Pipe2 1000]
      regsub -all "\b" $buffer2 "" buffer2
      .out.text insert 4.0 $buffer2
}
         
close $Pipe2
.out.text configure -state disabled

update idletask

after 6000 {
.statusBar.big config -text "Bitte drcken Sie F5, falls Sie die Anzeige der Jobs und deren Status erneuern wollen."
update idletask }