# the next line restarts using wish \
exec wish "$0" "$@"

###############################################################################
#                                                                             #
#    TkAntivir 1.51.01 - Tcl/Tk-Frontend fr Antivir/Linux                    #
#    Copyright (C) 1999-2006 Sebastian Geiges                                 #
#                                                                             #
#    TkAntivir benutzt BWidget 1.4.0 (C) 2000-2002 ActiveState Corp.          #
#                                                                             #
#    AntiVir ist ein registriertes Warenzeichen der Avira GmbH.               #
#                                                                             #
#    This program is free software; you can redistribute it and/or modify     #
#    it under the terms of the GNU General Public License as published by     #
#    the Free Software Foundation; either version 2 of the License, or        #
#    (at your option) any later version.                                      #
#                                                                             #
#    This program is distributed in the hope that it will be useful,          #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of           #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            #
#    GNU General Public License for more details.                             #
#                                                                             #
#    You should have received a copy of the GNU General Public License        #
#    along with this program; see the file COPYING.  If not, write to         #
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,         #
#    Boston, MA 02111-1307, USA.                                              #
#                                                                             #
###############################################################################

# Abfrage nach der Tcl/Tk-Version
if { $tk_version != "8.0" && $tk_version != "8.1" && $tk_version != "8.2" && $tk_version != "8.3" && $tk_version != "8.4"  && $tk_version != "8.5" } {
   puts "\a\n***************************************************************************"
   puts "*                                                                         *"     
   puts "*   TkAntivir 1.51 benoetigt mindestens Tcl/Tk Version 8.0 oder hoeher!   *"
   puts "*   Im Moment werden die Versionen 8.0.x bis 8.4 unterstuetzt.            *"
   puts "*   Tcl/Tk 8.0 oder hoeher erhalten Sie unter http://www.scriptics.com/   *"
   puts "*   oder evtl. auch von Ihrem Linux-Distributor.                          *"
   puts "*                                                                         *"
   puts "*   Sie benutzen im Moment Tcl $tcl_version und Tk $tk_version.                            *"
   puts "*                                                                         *"
   puts "***************************************************************************\n"
   exit
}

# globale Variablen fuer die Pfade
set path_to_antivir "/usr/lib/AntiVir"
set new_path_to_antivir $path_to_antivir
set path_to_tkantivir "/usr/X11R6/lib/TkAntivir"
set new_path_to_tkantivir $path_to_tkantivir
set path_log ""
set new_path_log  $path_log
set vdf_file ""
set file_defs "*.bin *.com *.dll *.doc *.dot *.exe *.htm* *.ov? *.sys *.wiz *.xtp"
set writeok 1
set sched int
set path_to_sched ""
set new_sched $sched
set new_path_to_sched $path_to_sched

# globale Variable fuer die sonst. Optionen von AntiVir
#set option_noboot 0
set option_trjoke 0
set option_nolnk 1
set option_wholefile 0
set option_lzexe 0
set option_nodef 0

# globale Variable fuer Ergebnisse von Dialogboxen
set buttonpressed -11
set find_ok -1
set send_ok -1

set currenttime ""

option add *font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

set report ""
set ondem ""

#####################################################################
# Lesen der Voreinstellungen aus der datei ~/.avtkrc                #
#####################################################################
proc read_preferences {} {

global path_to_antivir
global path_to_tkantivir
global path_log
global sched
global path_to_sched

# nur versuchen die Datei zu oeffnen, wenn sie auch da ist, um
# laestige Fehlermeldungen zu verhindern
if { [file exists "~/.avtkrc"] > 0} {

   # Datei zum Lesen oeffnen
   set File1 [open "~/.avtkrc" r]

   # Zeilenweise bis Dateiende lesen
   while {[gets $File1 line] > 0} {

         # Formatierung entfernen
         set line [string trim $line]

         # Kommentare ignorieren
         if {[string first "#" "$line"] == 0} continue;

            # String fuer Pfad zu AntiVir lesen
            if {[string first "antivir" "$line"] == 0} {
               set path_to_antivir [string range $line 9 end]
               set path_to_antivir [string trim $path_to_antivir]
	         }

	         # String fuer Pfad f. Log-Dateien lesen
            if {[string first "logpath" "$line"] == 0} {
               set path_log [string range $line 9 end]
               set path_log [string trim $path_log]
            }

            # String fuer Pfad f. Log-Dateien lesen
            if {[string first "tkavpath" "$line"] == 0} {
               set path_to_tkantivir [string range $line 10 end]
               set path_to_tkantivir [string trim $path_to_tkantivir]
            }

           # String fuer Scheduler lesen
           if {[string first "sched" "$line"] == 0} {
              set sched [string range $line 7 end]
              set sched [string trim $sched]
           }

           # String fuer Pfad zum Scheduler lesen
           if {[string first "pathsched" "$line"] == 0} {
              set path_to_sched [string range $line 11 end]
              set path_to_sched [string trim $path_to_sched]
           }

         }

   # Datei wieder schliessen
   close $File1
}

}


#####################################################################
# Schreiben der Voreinstellungen in die Datei "~/.avtkrc"           #
#####################################################################
proc write_preferences {} {

global path_to_antivir
global path_log
global path_to_tkantivir
global writeok
global sched
global path_to_sched

append avtest $path_to_antivir
append avtest "/antivir3.vdf"

# AntiVir, bitte melde dich!

if { [file exists $avtest] == 0} {
   catch { destroy .winf }
   toplevel .winf -class Dialog
   wm title .winf "Fehler"
   message .winf.warn -justify left \
                      -width 350 \
                      -text "\n \
                         AntiVir wurde nicht gefunden.\n \
                         Bitte korrigieren Sie Ihre Eingabe." \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

   label .winf.icon -bitmap warning
   button .winf.ok -text "OK" -command "set buttonpressed 1" \
                   -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
   pack .winf.icon -in .winf -padx 3m -pady 3m -side left
   pack .winf.warn .winf.icon .winf.ok
   tkwait variable buttonpressed

   # falls nein, auf 0 setzen
   set writeok 0
   destroy .winf

} else {

   # falls AntiVir gefunden wurde, writeok auf 1 setzen und schreiben

   # Datei zum Schreiben oeffnen
   set File1 [open "~/.avtkrc" w]

   # Variablen schreiben
   puts $File1 "# Pfad zu Antivir"
   puts $File1 "antivir  $path_to_antivir"
   puts $File1 "logpath  $path_log"
   puts $File1 "tkavpath  $path_to_tkantivir"
   puts $File1 "sched  $sched"
   if { [string compare "$path_to_sched" ""] != 0} {
      puts $File1 "pathsched  $path_to_sched"
   }

   # Datei wieder schliessen
   close $File1

   set writeok 1

   }

}


#####################################################################
# Aendern der Voreinstellungen in einem Dialogfenster               #
#####################################################################
proc do_preferences {} {

global path_to_antivir
global new_path_to_antivir
global path_to_tkantivir
global new_path_to_tkantivir
global path_log
global new_path_log
global buttonpressed
global writeok
global path_to_sched
global new_path_to_sched
global sched
global new_sched

# Wertsetzerei
set new_path_to_antivir $path_to_antivir
set new_path_to_tkantivir $path_to_tkantivir
set new_path_log $path_log
set new_sched $sched
set new_path_to_sched $path_to_sched

# Fenster erzeugen
catch { destroy .pref }
toplevel .pref -class Dialog
wm title .pref "Voreinstellungen"
wm geometry .pref +320+220

# Graue Titelueberschrift
frame .pref.l -relief flat -bg gray68 -bd 0
label .pref.l.title -text "Programmverzeichnisse" -bg gray68 -justify left -anchor nw -bd 0 \
	            -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
pack .pref.l .pref.l.title -side top -padx 1.7m -pady 1.7m -fill x

# Dialogelemente im Fenster plazieren
frame .pref.a
label .pref.a.l -width 20 -text "    Pfad zu AntiVir:" \
                -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .pref.a.e -width 22 \
                -relief sunken \
                -bd 2 \
                -textvariable new_path_to_antivir
pack .pref.a.l .pref.a.e -side left

frame .pref.b
label .pref.b.l -width 20 -text " Pfad fr Logdatei:" \
                -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .pref.b.e -width 22 \
                -relief sunken \
                -bd 2 \
                -textvariable new_path_log
pack .pref.b.l .pref.b.e -side left

frame .pref.d
label .pref.d.l -width 20 -text " Pfad zu TkAntivir:" \
                -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .pref.d.e -width 22 \
                -relief sunken \
                -bd 2 \
                -textvariable new_path_to_tkantivir
pack .pref.d.l .pref.d.e -side left

label .pref.z -text " " -font -*-Helvetica-Bold-R-Normal--*-10-*-*-*-*-*-*

# Graue Titelueberschrift
frame .pref.t -relief flat -bg gray68 -bd 0
label .pref.t.title -text "Scheduler-Einstellungen                                      " \
		    -bg gray68 -justify left -anchor nw -bd 0 \
	            -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
pack .pref.t.title -padx 1.7m -pady 1.7m -fill x -side top -expand yes

frame .pref.f
label .pref.f.l -width 20 -text "              Scheduler:" \
                -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
radiobutton .pref.f.sa -text "intern  " \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                       -variable new_sched \
                       -value int
radiobutton .pref.f.sb -text "extern           " \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                       -variable new_sched \
	                    -value ext
pack .pref.f.l .pref.f.sa .pref.f.sb -side left

frame .pref.g
label .pref.g.l -width 20 -text "Pfad zum Scheduler:   " \
                -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .pref.g.e -width 18 \
                -relief sunken \
                -bd 2 \
                -textvariable new_path_to_sched

if {[file exists "$path_log"] == 0} {
   button .pref.g.b -text "..." -command {choose}
} else {
   catch {image delete folder}
   image create photo folder -file $path_to_tkantivir/folder.gif
   button .pref.g.b -image folder -command {choose}
}


pack .pref.g.l .pref.g.e .pref.g.b -side left


# Buttonleiste
frame .pref.button

button .pref.button.ok -text "OK" \
                       -command "set buttonpressed 1" \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

button .pref.button.cancel -text "Abbrechen" \
                           -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-* \
                           -command "set buttonpressed 0"

pack  .pref.button.ok .pref.button.cancel -side left -pady 1m

pack .pref.l .pref.a .pref.b .pref.d .pref.z .pref.t .pref.f .pref.g .pref.button

# Warten auf Button
tkwait variable buttonpressed

# wenn es der Ok-Button war, werden die Einstellungen uebernommen und mit write_preferences
# geschrieben
if {$buttonpressed == 1} {
   set path_to_antivir $new_path_to_antivir
   set path_log $new_path_log
   set path_to_tkantivir $new_path_to_tkantivir
   set sched $new_sched
   set path_to_sched $new_path_to_sched
   write_preferences
   if {$writeok == 1} {
      destroy .pref
   } else {
      do_preferences
   }
} else {
   destroy .pref
}

}


#####################################################################
# Auswaehlen des externen Schedulers                                #
#####################################################################
proc choose {} {

set schedfile [tk_getOpenFile -title "Datei auswhlen"]
if { [string compare "$schedfile" ""] != 0} {
   .pref.g.e delete 0 end
   .pref.g.e insert insert $schedfile
}

}


#####################################################################
# Anzeigen der Copyrightmeldung					                                #
#####################################################################
proc do_about {} {

catch { destroy .copy }
toplevel .copy -class Dialog
wm title .copy "Info ber TkAntivir"
wm geometry .copy +250+250
frame .copy.top

# Copyright mit GPL-Hinewis
label .copy.top.about1 -justify left \
                     -text "TkAntivir 1.51.01 - Tcl/Tk-Frontend fr H+BEDV AntiVir fr Linux" \
		     -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
label .copy.top.about2 -justify left \
                     -text "  Copyright (C) 1999-2006 Sebastian Geiges\n \
                        Released under the GNU General Public License (GPL).\n\n \
                      		TkAntivir benutzt BWidget 1.4.0 (C) 2001-2002 ActiveState Corp.\n\n \
                        AntiVir ist ein registriertes Warenzeichen der Avira GmbH.\n\n \
                        This program is distributed in the hope that it will be\n \
                        useful, but WITHOUT ANY WARRANTY; without even the\n \
                        implied warranty of MERCHANTABILITY or FITNESS FOR\n \
                     			A PARTICULAR PURPOSE. See the GNU General Public\n \
                     			License for more details." \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack .copy.top .copy.top.about1 .copy.top.about2 -side top -padx 3m -pady 2m

button .copy.ok -text "OK" -command "set buttonpressed 1" \
               -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack .copy.top .copy.ok -side top

tkwait variable buttonpressed

destroy .copy

}


#####################################################################
# Anzeigen der Lizenz- und VDF-Informationen                 			    #
#####################################################################
proc do_vdfinfo {} {

global antivirver
    
catch { destroy .vdf }
toplevel .vdf -class Dialog
wm title .vdf "Infos ber AntiVir"
wm geometry .vdf +300+300

# Graue Titelueberschrift
frame .vdf.l -relief flat -bg gray68 -bd 0
label .vdf.l.title -text "Informationen ber AntiVir" -bg gray68 -justify left -anchor nw -bd 0 \
                   -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
pack .vdf.l .vdf.l.title -side top -padx 1.7m -pady 1.7m -fill x

# Box

frame .vdf.output

text .vdf.output.text -relief sunken -bd 2 -bg white \
              -yscrollcommand ".vdf.output.scroll set" \
 	      -font *-Courier-Medium-R-Normal--*-120-*-*-*-*-*-* -width 60 -height 20
scrollbar .vdf.output.scroll -command ".vdf.output.text yview"
	      
.vdf.output.text insert end $antivirver

.vdf.output.text delete 1.0 2.0

pack .vdf.output.scroll -side right -fill y
pack .vdf.output.text
pack .vdf.output

# Buttons
button .vdf.ok -text "OK" -command "set buttonpressed 1" \
               -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack .vdf.l .vdf.output .vdf.ok -side top

tkwait variable buttonpressed

destroy .vdf

}


#####################################################################
# Permanentes Ermitteln der aktuellen Uhrzeit (mit Rekursion)			    #
#####################################################################
proc update_time {} {
 global currenttime 

 set secs [clock seconds]
 set time [clock format $secs -format "%H:%M:%S"]

 set currenttime "$time"
 after 1000 update_time
}


#####################################################################
# Report-Viewer mit automatischer Viruswarnung			                   #
#####################################################################
proc textToggle {cmd1 sleep1 cmd2 sleep2} {
   catch {
	   eval $cmd1
	   after $sleep1 [list textToggle $cmd2 $sleep2 $cmd1 $sleep1]
   }
}


proc virusalarm {} {
   if {[winfo depth .repo.output] > 1} {
      textToggle ".repo.output.text tag configure search -background \
	    #ce5555 -foreground white" 800 ".repo.output.text tag configure \
	    search -background {} -foreground {}" 200
   } else {
      textToggle ".repo.output.text tag configure search -background \
	    black -foreground white" 800 ".repo.output.text tag configure \
	    search -background {} -foreground {}" 200
   }

   set string "VIRUS:"
   set tag search
   .repo.output.text tag remove search 0.0 end
   if {$string == ""} {
	   return
   }
   set cur 1.0
   while 1 {
	   set cur [.repo.output.text search -count length $string $cur end]
	   if {$cur == ""} {
	      break
	   }
      .repo.output.text tag add $tag $cur "$cur + $length char"
	   set cur [.repo.output.text index "$cur + $length char"]
   }

}


proc do_report {} {

global path_log
global recipient

#-----------------------------------------------------------#
#   Dateitypen-Name             Erweiterung     Mac-Typen   #
#-----------------------------------------------------------#
set types {
    {"Report-Dateien"           {.log .rep .av} TEXT}
    {"Text-Dateien"             {.txt .doc}     TEXT}
    {"Alle Dateien"             *}
}

# Auswahldialog mit Bordmitteln (Tk-eigen) anzeigen
set repfile [tk_getOpenFile -filetypes $types -title "Datei ffnen..." -initialdir $path_log]

if {$repfile != ""} {

catch { destroy .repo }
toplevel .repo -class Dialog
wm title .repo "TkAntivir Report-Viewer - $repfile"
wm resizable .repo 1 1

frame .repo.output

text .repo.output.text -relief sunken -bd 2 \
                      -yscrollcommand ".repo.output.scroll set" -bg white \
		      -font *-Courier-Medium-R-Normal--*-120-*-*-*-*-*-*
scrollbar .repo.output.scroll -command ".repo.output.text yview"

frame .repo.buttons -relief groove -bd 2
label .repo.buttons.emaill -text "Virus-Warnung an:" \
                               -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .repo.buttons.emaile -width 22 \
                            -relief sunken \
			    -bd 2 \
			    -textvariable recipient \
			    -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
button .repo.buttons.send -text "Absenden" -command do_send \
                         -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

button .repo.buttons.ok -text "Schlieen" -command "destroy .repo" \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
button .repo.buttons.print -text "Datei drucken" -command "exec lpr $repfile" \
                          -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack .repo.output.scroll -side right -fill y
pack .repo.output.text
pack .repo.output

pack .repo.buttons  -fill x -expand yes
pack .repo.buttons.ok .repo.buttons.print -side right -pady 1m -padx 1m

set Pipe2 [open $repfile r+]

while {![eof $Pipe2]} {
      set buffer2 [read $Pipe2 1000]
      regsub -all "\b" $buffer2 "" buffer2
      .repo.output.text insert end $buffer2
}

close $Pipe2

virusalarm

}

}


#####################################################################
# TkAntivir-Scheduler starten					                                  #
#####################################################################
proc do_sched {} {

global path_to_tkantivir
global sched
global path_to_sched

if { [string compare "$sched" "int"] == 0} {
   set command "|wish "
   append command "$path_to_tkantivir"
   append command "/scheduler.tcl"
   open $command r+
} else {
   set command "|"
   append command "$path_to_sched"
   open $command
}

}


#####################################################################
# Profil-Datei laden     			         	                              #
#####################################################################
proc do_loadprof {} {

global path_log
global path_to_search
global sub_dir
global option_nolnk
#global option_noboot
global option_trjoke
global option_wholefile
global option_nodef
global option_lzexe
global option_zip
#global moveto
global file_defs
global option_rep
global option_mac
global scpfile

#-----------------------------------------------------------#
#   Dateitypen-Name             Erweiterung      Mac-Typen  #
#-----------------------------------------------------------#
set types {
    {"TkAntivir-Profil-Datei"   {.scp}           TEXT}
    {"Alle Dateien" 		*}
}

# Auswahldialog mit Bordmitteln (Tk-eigen) anzeigen
set scpfile [tk_getOpenFile -filetypes $types -title "Profil-Datei ffnen" -initialdir $path_log]

if { [file exists $scpfile] > 0} {

   # Datei zum Lesen oeffnen
   set File1 [open $scpfile r]

   # Zeilenweise bis Dateiende lesen
   while {[gets $File1 line] > 0} {

         # Formatierung entfernen
         set line [string trim $line]

         # Kommentare ignorieren
         if {[string first "#" "$line"] == 0} continue;

            if {[string first "pathtosearch" "$line"] == 0} {
               set path_to_search [string range $line 16 end]
               set path_to_search [string trim $path_to_search]
       	    }

            if {[string first "subdir" "$line"] == 0} {
               set sub_dir [string range $line 16 end]
               set sub_dir [string trim $sub_dir]
            }

            if {[string first "nodef" "$line"] == 0} {
               set option_nodef [string range $line 16 end]
               set option_nodef [string trim $option_nodef]
            }

           if {[string first "filedefs" "$line"] == 0} {
              set file_defs [string range $line 16 end]
              set file_defs [string trim $file_defs]
           }

#       	   if {[string first "noboot" "$line"] == 0} {
#              set option_noboot [string range $line 16 end]
#              set option_noboot [string trim $option_noboot]
#           }
    
      
       	   if {[string first "trjoke" "$line"] == 0} {
              set option_trjoke [string range $line 16 end]
              set option_trjoke [string trim $option_trjoke]
           }

       	   if {[string first "lzexe" "$line"] == 0} {
              set option_lzexe [string range $line 16 end]
              set option_lzexe [string trim $option_lzexe]
           }

           if {[string first "zip" "$line"] == 0} {
              set option_zip [string range $line 16 end]
              set option_zip [string trim $option_zip]
           }
      
	        if {[string first "nolnk" "$line"] == 0} {
              set option_nolnk [string range $line 16 end]
              set option_nolnk [string trim $option_nolnk]
           }

	        if {[string first "wholefile" "$line"] == 0} {
              set option_wholefile [string range $line 16 end]
              set option_wholefile [string trim $option_wholefile]
           }

	        if {[string first "rep" "$line"] == 0} {
              set option_rep [string range $line 16 end]
              set option_rep [string trim $option_rep]
           }

       	   if {[string first "mac" "$line"] == 0} {
              set option_mac [string range $line 16 end]
              set option_mac [string trim $option_mac]
           }

#	        if {[string first "move" "$line"] == 0} {
#              set moveto [string range $line 16 end]
#              set moveto [string trim $moveto]
#           }

         }

   # Datei wieder schliessen
   close $File1

   .statusBar.big config -text "TkAntivir-Profil-Datei: $scpfile"
   update idletask

   .menu.file.menu delete 2
   update idletask

   .menu.file.menu insert 2 command -label "Profil auf KDE-Desktop" \
                            -command do_kdeprof \
                            -underline 11 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
   update idletask

}


}


#####################################################################
# Profil-Datei abspeichern                        		                #
#####################################################################
proc do_saveprof {} {

global path_log
global path_to_search
global sub_dir
global option_nolnk
#global option_noboot
global option_trjoke
global option_wholefile
global option_nodef
global option_lzexe
global option_zip
#global moveto
global file_defs
global option_rep
global option_mac
global find_ok
global avver
global scpfile

#-----------------------------------------------------------#
#   Dateitypen-Name             Erweiterung      Mac-Typen  #
#-----------------------------------------------------------#
set types {
    {"TkAntivir-Profil-Datei"   {.scp}           TEXT}
    {"Alle Dateien"             *}
}

# Auswahldialog mit Bordmitteln (Tk-eigen) anzeigen
set scpfile [tk_getSaveFile -filetypes $types -title "Profil-Datei speichern" -initialdir $path_log]

if { [string compare "$scpfile" ""] != 0} {

   set File1 [open $scpfile w]

   # Variablen schreiben
   puts $File1 "# TkAntivir SCP File Format v1.51.01 - Do not modify!"
   puts $File1 "#"
   puts $File1 "pathtosearch    $path_to_search"
   puts $File1 "subdir          $sub_dir"
   puts $File1 "nodef           $option_nodef"
   puts $File1 "filedefs        $file_defs"
#   puts $File1 "noboot          $option_noboot"
   puts $File1 "trjoke          $option_trjoke"
   puts $File1 "lzexe           $option_lzexe"
   puts $File1 "zip             $option_zip"
   puts $File1 "nolnk           $option_nolnk"
   puts $File1 "wholefile       $option_wholefile"
   puts $File1 "rep             $option_rep"
   puts $File1 "mac             $option_mac"
#   puts $File1 "move            $moveto"

   # Datei wieder schliessen
   close $File1

   if { [file exists $scpfile] > 0} {

      # Datei zum Lesen oeffnen
      set File1 [open $scpfile r]

      # Zeilenweise bis Dateiende lesen
      while {[gets $File1 line] > 0} {

            # Formatierung entfernen
            set line [string trim $line]

            # Kommentare ignorieren
            if {[string first "#" "$line"] == 0} continue;

               if {[string first "pathtosearch" "$line"] == 0} {
                  set path_to_search [string range $line 16 end]
                  set path_to_search [string trim $path_to_search]
       	       }

               if {[string first "subdir" "$line"] == 0} {
                  set sub_dir [string range $line 16 end]
                  set sub_dir [string trim $sub_dir]
               }

               if {[string first "nodef" "$line"] == 0} {
                  set option_nodef [string range $line 16 end]
                  set option_nodef [string trim $option_nodef]
               }

              if {[string first "filedefs" "$line"] == 0} {
                 set file_defs [string range $line 16 end]
                 set file_defs [string trim $file_defs]
              }

#       	      if {[string first "noboot" "$line"] == 0} {
#                 set option_noboot [string range $line 16 end]
#                 set option_noboot [string trim $option_noboot]
#              }

       	      if {[string first "trjoke" "$line"] == 0} {
                 set option_trjoke [string range $line 16 end]
                 set option_trjoke [string trim $option_trjoke]
              }

         
              if {[string first "lzexe" "$line"] == 0} {
                 set option_lzexe [string range $line 16 end]
                 set option_lzexe [string trim $option_lzexe]
              }

               if {[string first "zip" "$line"] == 0} {
                 set option_zip [string range $line 16 end]
                 set option_zip [string trim $option_zip]
              }
         
              if {[string first "nolnk" "$line"] == 0} {
                 set option_nolnk [string range $line 16 end]
                 set option_nolnk [string trim $option_nolnk]
              }

              if {[string first "wholefile" "$line"] == 0} {
                 set option_wholefile [string range $line 16 end]
                 set option_wholefile [string trim $option_wholefile]
              }

       	      if {[string first "rep" "$line"] == 0} {
                 set option_rep [string range $line 16 end]
                 set option_rep [string trim $option_rep]
              }

              if {[string first "mac" "$line"] == 0} {
                 set option_mac [string range $line 16 end]
                 set option_mac [string trim $option_mac]
              }

#              if {[string first "move" "$line"] == 0} {
#                 set moveto [string range $line 16 end]
#                 set moveto [string trim $moveto]
#              }

           }

   # Datei wieder schliessen
   close $File1
   }
   .statusBar.big config -text "TkAntivir-Profil-Datei: $scpfile"
   update idletask

   .menu.file.menu delete 2
   update idletask

   .menu.file.menu insert 2 command -label "Profil auf KDE-Desktop" \
                            -command do_kdeprof \
                            -underline 11 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
   update idletask

}


}

#####################################################################
# Profil-Datei als Link auf KDE-Desktop legen                       #
#####################################################################
proc do_kdeprof {} {

global path_log
global scpfile
global path_to_tkantivir
global profname
global new_profname

# Fenster erzeugen
catch { destroy .kdeprof }
toplevel .kdeprof -class Dialog
wm title .kdeprof "Profil-Name fr KDE-Untersttzung"
wm geometry .kdeprof +300+300

# Dialogelemente im Fenster plazieren

label .kdeprof.l -width 39 -text "Geben Sie den Profilnamen ein (mglichst kurz):     " \
                 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
entry .kdeprof.e -width 35 \
               -relief sunken \
               -bd 2 \
               -textvariable new_profname

# Buttonleiste

button .kdeprof.button -text "    Weiter >    " \
                      -command "set buttonpressedprof 1" \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack .kdeprof.l .kdeprof.e .kdeprof.button -ipadx 3m -side top -anchor nw

tkwait variable buttonpressedprof

set profname $new_profname
destroy .kdeprof

set proflnk $path_log
append proflnk "/KDesktop/"
append proflnk $profname
append proflnk ".kdelnk"

if { [string compare "$proflnk" ""] != 0} {

   set File1 [open $proflnk w]

   # Variablen schreiben

   puts $File1 "# KDE Config File - Created by TkAntivir 1.51.01"
   puts $File1 "\[KDE Desktop Entry]"
   puts $File1 "Name\[fi]=Sovellus"
   puts $File1 "SwallowExec="
   puts $File1 "SwallowTitle="
   puts $File1 "Name\[ru]="
   puts $File1 "BinaryPattern="
   puts $File1 "Name\[hr]=Program"
   puts $File1 "Name\[sl]=Uporabniki program"
   puts $File1 "Name\[pl]=Aplikacja"
   puts $File1 "Name=Application"
   puts $File1 "Name\[ca]=Aplicacions"
   puts $File1 "Name\[it]=Applicazione"
   puts $File1 "Name\[da]=Anvendelse"
   puts $File1 "MimeType="
   puts $File1 "Name\[de]=Anwendung"
   puts $File1 "Exec=$path_to_tkantivir/tkantivir -profile $scpfile"
   puts $File1 "Name\[cs]=Aplikace"
   puts $File1 "Name\[sv]=Program"
   puts $File1 "Icon=exec.xpm"
   puts $File1 "TerminalOptions="
   puts $File1 "Name\[br]=Arload"
   puts $File1 "Name\[sk]=Aplikcia"
   puts $File1 "Path="
   puts $File1 "Name\[pt_BR]=Aplicativo"
   puts $File1 "Type=Application"
   puts $File1 "Name\[es]=Aplicaciones"
   puts $File1 "Name\[is]=Forrit"
   puts $File1 "Name\[pt]=Aplicao"
   puts $File1 "Comment\[de]="
   puts $File1 "Terminal=0"
   puts $File1 "Name\[no]=Applikasjon"
   puts $File1 "Name\[hu]=Applikci"
   puts $File1 "Name\[ro]=Aplicaie"

   # Datei wieder schliessen
   close $File1


}

   .statusBar.big config -text "TkAntivir-Profil-Datei: $scpfile"
   update idletask

}


#####################################################################
# Profil-Datei laden von KDE-Desktop                                #
#####################################################################
proc do_kdeprofload {} {

global path_log
global path_to_search
global sub_dir
global option_nolnk
#global option_noboot
global option_trjoke
global option_wholefile
global option_nodef
global option_lzexe
global option_zip
#global moveto
global file_defs
global option_rep
global option_mac
global scpfile

if { [file exists $scpfile] > 0} {

   # Datei zum Lesen oeffnen
   set File1 [open $scpfile r]

   # Zeilenweise bis Dateiende lesen
   while {[gets $File1 line] > 0} {

         # Formatierung entfernen
         set line [string trim $line]

         # Kommentare ignorieren
         if {[string first "#" "$line"] == 0} continue;

            if {[string first "pathtosearch" "$line"] == 0} {
               set path_to_search [string range $line 16 end]
               set path_to_search [string trim $path_to_search]
       	    }

            if {[string first "subdir" "$line"] == 0} {
               set sub_dir [string range $line 16 end]
               set sub_dir [string trim $sub_dir]
            }

            if {[string first "nodef" "$line"] == 0} {
               set option_nodef [string range $line 16 end]
               set option_nodef [string trim $option_nodef]
            }

           if {[string first "filedefs" "$line"] == 0} {
              set file_defs [string range $line 16 end]
              set file_defs [string trim $file_defs]
           }

#       	   if {[string first "noboot" "$line"] == 0} {
#              set option_noboot [string range $line 16 end]
#              set option_noboot [string trim $option_noboot]
#           }

       	   if {[string first "trjoke" "$line"] == 0} {
              set option_trjoke [string range $line 16 end]
              set option_trjoke [string trim $option_trjoke]
           }

       	   if {[string first "lzexe" "$line"] == 0} {
              set option_lzexe [string range $line 16 end]
              set option_lzexe [string trim $option_lzexe]
           }

          if {[string first "zip" "$line"] == 0} {
              set option_zip [string range $line 16 end]
              set option_zip [string trim $option_zip]
           }
     
       	   if {[string first "nolnk" "$line"] == 0} {
              set option_nolnk [string range $line 16 end]
              set option_nolnk [string trim $option_nolnk]
           }

       	   if {[string first "wholefile" "$line"] == 0} {
              set option_wholefile [string range $line 16 end]
              set option_wholefile [string trim $option_wholefile]
           }

       	   if {[string first "rep" "$line"] == 0} {
              set option_rep [string range $line 16 end]
              set option_rep [string trim $option_rep]
           }

       	   if {[string first "mac" "$line"] == 0} {
              set option_mac [string range $line 16 end]
              set option_mac [string trim $option_mac]
           }

#       	   if {[string first "move" "$line"] == 0} {
#              set moveto [string range $line 16 end]
#              set moveto [string trim $moveto]
#           }

         }

   # Datei wieder schliessen
   close $File1

   .statusBar.big config -text "TkAntivir-Profil-Datei: $scpfile"
   update idletask

   .menu.file.menu delete 2
   update idletask

   .menu.file.menu insert 2 command -label "Profil auf KDE-Desktop" \
                            -command do_kdeprof \
                            -underline 11 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
   update idletask

}


}


#####################################################################
# Virensuche -  die "Engine" von TkAntivir zur Uebergabe der Op-    #
# tionen an H+BEDV AntiVir/X und dessen Ausfhrung                  #
#####################################################################
proc do_find {} {

# globale Optionen fuer Virensuche/-entfernung
global path_to_antivir
global sub_dir
global path_log
global path_to_search
global option_nolnk
#global option_noboot
global option_trjoke
global option_wholefile
global option_nodef
global option_lzexe
global option_zip
#global moveto
global file_defs
global option_rep
global option_mac
global find_ok
global path_to_tkantivir
global report

.chooser raise avproto
    
    $report.output.text configure -state normal
    
$report.output.text delete 0.0 end  

$report.output.text insert end "TkAntivir-Report:\n"
$report.output.text insert end "=================\n\n"

$report.output.text insert end "Informationen:\n"
$report.output.text insert end "--------------\n\n"

# testen, ob Antivir vorhanden ist
if { [file exists $path_to_antivir] == 0} {
   $report.output.text insert end "Pfad zu AntiVir: $path_to_antivir\n"
   $report.output.text insert end "AntiVir/Linux konnte nicht gefunden werden.\n"
   $report.output.text insert end "Prfen Sie die Voreinstellungen.\n"
} else {
    $report.output.text insert end "Pfad zu AntiVir: $path_to_antivir\n"

    if { [string compare "$sub_dir" "1"] == 0} {
       $report.output.text insert end "Verzeichnisse: inkl. Unterverz.\n"
    } elseif { [string compare "$sub_dir" "0"] == 0} {
       $report.output.text insert end "Verzeichnisse: nur aktuelles Verz.\n"
    }

    # Protokoll aktualisieren
    update

    # Kommando zusammenstellen
    set antivircommand $path_to_antivir
    append antivircommand "/antivir "
    append antivircommand $path_to_search
    append antivircommand "/"

    # Typeneingrenzung behandeln
    if {$option_nodef == 1} {
       append antivircommand " -nodef "
       append antivircommand $file_defs
    } else {
       append antivircommand " -allfiles"
    }

    # Suchoption "auch Unterverzeichnisse" beruecksichtigen
    if {$sub_dir == "1"} {
       append antivircommand " -s"
    }

    # Option "Bootsektorprfung abschalten" beruecksichtigen
#    if {$option_noboot == 1} {
 #      append antivircommand " -noboot"
#    }
  
    # Option "Dialer suchen" beruecksichtigen
    if {$option_trjoke == 1} {
       append antivircommand " --alltypes"
    }

    # Option "folge keinen Symlinks" beruecksichtigen (geht nur hbedv.key)
    if {$option_nolnk == 1} {
       append antivircommand " -nolnk"
    }

    # Option "ganze Dateien durchsuchen" beruecksichtigen
    if {$option_wholefile == 1} {
       append antivircommand " -v"
    }

    # Option "ZIP-Archive durchsuchen" beruecksichtigen
    if {$option_zip == 1} {
       append antivircommand " -z"
    }
   
    # Option "PKLite + LZExe" beruecksichtigen
    if {$option_lzexe == 1} {
       append antivircommand " -nopack"
    }

    # Reparaturoptionen auswerten
    if { [string compare "$option_rep" "none"] != 0} {
       if { [string compare "$option_rep" "rep"] == 0} {
       	  append antivircommand " -e"
       }
       if { [string compare "$option_rep" "ren"] == 0} {
       	  append antivircommand " -ren"
       }
       if { [string compare "$option_rep" "loe"] == 0} {
          append antivircommand " -del"
       }
 #      if { [string compare "$option_rep" "move"] == 0} {
  #        append antivircommand " -moveto $moveto"
  #     }
    }

    # Makro-Rep.optionen auswerten
    if { [string compare "$option_mac" "none"] != 0} {
       if { [string compare "$option_mac" "delf"] == 0} {
	  append antivircommand " -dmdel"
       }
       if { [string compare "$option_mac" "delm"] == 0} {
	  append antivircommand " -dmds"
       }
       if { [string compare "$option_mac" "delam"] == 0} {
	  append antivircommand " -dmda"
       }
    }

    # Log-Aufruf/Pfad fuer Uebergabe in Protokoll
    append antivircommand " -rf"
    append antivircommand $path_log
    append antivircommand "/avlinux.log -ro -lang=DE"

    # Kommando nochmal anzeigen (fuer Ueberpruefung)
    $report.output.text insert end "Das Kommando waere: $antivircommand\n"

    # Sicherheitsabfrage


    
    set command $antivircommand

    destroy .questdlg

    set find_ok [MessageDlg .questdlg -parent $report -type yesno -icon question \
               -message "Soll AntiVir mit dem Befehl\n\n$command\n\nausgefhrt werden?" \
               -width 290]
    
    wm iconify .

    if {$find_ok == 1} {

        # doch nicht suchen
        $report.output.text insert end "Suchvorgang abgebrochen\n"
        wm deiconify .

    } else {

        # Jetzt wirklich suchen
        $report.output.text insert end "AntiVir wurde gestartet...\n"
        set command "|"
        append command "xterm -T \"AntiVir fr Linux\" -e " $antivircommand
        # append command $antivircommand
        append command " 2> /dev/null"
        $report.output.text insert end "\nAntiVir/Linux-Report:\n"
        $report.output.text insert end "---------------------\n"

        set Pipe1 [open $command r+]
        close $Pipe1

	 wm deiconify .
 
     # AntiVir-Report ins Protokollfenster (aus Log-Pfad)
     set command2 $path_log
	 append command2 "/avlinux.log"

         set Pipe2 [open $command2 r+]

         while {![eof $Pipe2]} {
               set buffer2 [read $Pipe2 1000]
               regsub -all "\b" $buffer2 "" buffer2
               $report.output.text insert end $buffer2
         }

         $report.output.text insert end "AntiVir beendet, bitte Ausgabe lesen!"

         close $Pipe2

         if {[winfo depth $report.output] > 1} {
            textToggle "$report.output.text tag configure search -background \
       	    #ce5555 -foreground white" 800 "$report.output.text tag configure \
       	    search -background {} -foreground {}" 200
         } else {
            textToggle "$report.output.text tag configure search -background \
       	    black -foreground white" 800 "$report.output.text tag configure \
       	    search -background {} -foreground {}" 200
         }

         set string "VIRUS:"
         set tag search
         $report.output.text tag remove search 0.0 end
         if {$string == ""} {
    	       return
         }
         set cur 1.0
         while 1 {
             	   set cur [$report.output.text search -count length $string $cur end]
             	   if {$cur == ""} {
             	      break
                 }
                 $report.output.text tag add $tag $cur "$cur + $length char"
              	  set cur [$report.output.text index "$cur + $length char"]
         }

      }


    }
    
    $report.output.text configure -state disabled
    
}


#####################################################################
# Aufruf des Internet Update von AntiVir fr Linux                  #
#####################################################################
proc do_update {} {
global path_to_antivir
global report

# .chooser raise avproto

# $report.output.text configure -state normal
    
# $report.output.text delete 0.0 end  
    
# after 200 {
   
set antivircommand $path_to_antivir
append antivircommand "/antivir --update"
    
set command "|"
append command "xterm -T \"AntiVir Internet Update\" -e " $antivircommand
append command $antivircommand
append command " 2> /dev/null"

    
set Pipe [open $command r+]
    
# while {![eof $Pipe]} {
#       set buffer [read $Pipe 1000]
#       regsub -all "\b" $buffer "" buffer
#       $report.output.text insert end $buffer
#  }

close $Pipe
    
# }
    
}


#####################################################################
# HAUPTPROGRAMM - T k A n t i v i r   1 . 5 1 . 0 1                 #
#####################################################################
read_preferences
write_preferences

if {[file exists "$path_log"] == 0} {

   catch { destroy .win }
   toplevel .win -class Dialog
   wm title .win "TkAntivir-Installation"
   wm geometry .win +300+300
   message .win.warn -justify left \
                      -width 350 \
                      -text "\n\n \
			    TkAntivir ist noch nicht fertig konfiguriert.\n \
			    Geben Sie bitte im nchsten Fenster die\n  geforderten Daten ein!\n" \
		      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

   label .win.icon -bitmap warning
   button .win.ok -text "OK" -command "set buttonpressed 1" \
                  -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
   pack .win.icon -in .win -padx 3m -pady 3m -side left
   pack .win.warn .win.icon .win.ok
   tkwait variable buttonpressed
   destroy .win

   do_preferences
}

# antivir.vdf-Kopf auslesen
global vdf_file
global vdf_ver
global vdf_fup
global vdf_date
global vdf_avver
global scpfile
global antivirver

append vdf_file $path_to_antivir
append vdf_file "/antivir3.vdf"
set File1 [open $vdf_file r]
while {[gets $File1 line] > 0} {
set line [string trim $line]

if {[string first "Virus Database File" "$line"] == 0} continue;
   if {[string first "Version: " "$line"] == 0} {
      set vdf_ver [string range $line 9 end]
      set vdf_ver [string trim $vdf_ver]
   }

   if {[string first "Version: " "$line"] == 0} {
      set vdf_avver [string range $line 9 12]
      set vdf_avver [string trim $vdf_avver]
   }

   if {[string first "FUP: " "$line"] == 0} {
      set vdf_fup [string range $line 5 end]
      set vdf_fup [string trim $vdf_fup]
      if { [string compare "$vdf_fup" "0"] == 0} {      
         set vdf_fup "CD-Grundversion"
      }
      if { [string compare "$vdf_fup" "1"] == 0} {      
         set vdf_fup "FUSE 6"
      }
      if { [string compare "$vdf_fup" "2"] == 0} {      
         set vdf_fup "FUSE 6/wi"
      }
      if { [string compare "$vdf_fup" "3"] == 0} {      
         set vdf_fup "FUSE 6/wi"
      }
   }
 
   if {[string first "License date: " "$line"] == 0} {
      set vdf_date [string range $line 14 end]
      set vdf_date [string trim $vdf_date]
   }
}

# Datei schlieen
close $File1

# Version der "antivir"-Programmdatei abfragen
set cmdantver "|"
append cmdantver $path_to_antivir
append cmdantver "/antivir --version"
set Pipe1 [open $cmdantver r+]
while {![eof $Pipe1]} {
       set antivirver [read $Pipe1 10000]
#       regsub -all "\n" $antivirver "" antivirver
}

# BWidget 1.4.0 Bibliothek laden
lappend auto_path "$path_to_tkantivir/BWidget-1.4.0"
package require BWidget 1.4.0
variable resources "de"
option read [file join $path_to_tkantivir "BWidget-1.4.0/lang" "$resources.rc"]

# Start-Fenster
catch { destroy .wina }
toplevel .wina -class Dialog
wm title .wina "Initialisierung..."
wm geometry .wina +300+150

# Bild vorbereiten u. anzeigen
catch {image delete image1}
image create photo image1 -file $path_to_tkantivir/tkantivir.gif
label .wina.img -image image1 -relief flat
pack .wina.img

set prgindic 0
set prg [ProgressBar .wina.prog -maximum 100 -height 20 -width 270 -variable prgindic]
pack $prg -pady 1m
after 300 {
set prgindic 0
update idletasks
after 40 {set prgindic 10
update idletasks}
after 80 {set prgindic 20
update idletasks}
after 120 {set prgindic 30
update idletasks}
after 160 {set prgindic 40
update idletasks}
after 200 {set prgindic 50
update idletasks}
after 240 {set prgindic 60
update idletasks}
after 280 {set prgindic 70
update idletasks}
after 320 {set prgindic 80
update idletasks}
after 360 {set prgindic 90
update idletasks}
after 400 {set prgindic 100
update idletasks}

}

# ###################################################################
# Layout des Haupt-Fensters
#
frame .menu -relief raised -bd 1
frame .oben
frame .mitte
frame .unten
frame .links
frame .rechts
frame .nochrechter

# ###################################################################
# Das Menue
menubutton .menu.file -text "Datei" -menu .menu.file.menu -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
menubutton .menu.action -text "Aktion" -menu .menu.action.menu -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
menubutton .menu.help -text "Hilfe" -menu .menu.help.menu -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
pack .menu.file .menu.action .menu.help -side left

menu .menu.file.menu -tearoff 0

.menu.file.menu add command -label "Profil-Datei laden..." \
                            -command do_loadprof \
                            -underline 13 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.file.menu add command -label "Profil-Datei speichern..." \
                            -command do_saveprof \
                            -underline 13 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.file.menu add command -label "Profil auf KDE-Desktop" \
                            -command do_kdeprof \
                            -state disabled \
                            -underline 11 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.file.menu add separator

.menu.file.menu add command -label "Voreinstellungen...   " \
                            -command do_preferences \
                            -accelerator F9 \
                            -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.file.menu add separator

.menu.file.menu add command -label "Beenden" \
                            -command exit \
                     			    -accelerator Meta-x \
                            -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

menu .menu.action.menu -tearoff 0

.menu.action.menu add command -label "Suche starten..." \
                            -command do_find \
			    -accelerator F2 \
                            -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.action.menu add separator

.menu.action.menu add command -label "Report-Viewer..." \
                              -command do_report \
                              -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.action.menu add command -label "Scheduler"\
                              -command do_sched \
                              -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.action.menu add separator

.menu.action.menu add command -label "Internet Update"\
                              -command do_update \
                              -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*


menu .menu.help.menu -tearoff 0

.menu.help.menu add command -label "VDF-/Lizenz-Infos..." \
                            -command do_vdfinfo \
                            -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

.menu.help.menu add command -label "ber TkAntivir..." \
                            -command do_about \
			                   -accelerator F1 \
                            -underline 0 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*


# Iconleiste mit Abhaengigkeit von der Farbtiefe
if {[winfo depth .] <= 8} {
frame .icon -relief sunken -bd 2 -background white -highlightbackground white
catch {image delete imagea}
image create bitmap imagea -file $path_to_tkantivir/find.xbm
Button .icon.button1 -image imagea -text "Suchen" -command do_find -relief flat -background white -highlightbackground white -helptext "Suchen"
button .icon.button1b -text "Suchen" -command do_find -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imaget}
image create bitmap imaget -file $path_to_tkantivir/clock.xbm
Button .icon.buttont -image imaget -text "Timer" -command do_sched -relief flat -background white -highlightbackground white -helptext "Scheduler starten"
button .icon.buttontb -text "Scheduler" -command do_sched -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imageb}
image create bitmap imageb -file $path_to_tkantivir/text.xbm
Button .icon.button2 -image imageb -text "Report" -command do_report -relief flat -background white -highlightbackground white -helptext "Report-Viewer starten"
button .icon.button2b -text "Report-Viewer" -command do_report -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imagec}
image create bitmap imagec -file $path_to_tkantivir/pref.xbm
Button .icon.button3 -image imagec -text "Einstellungen" -command do_preferences -relief flat -background white -highlightbackground white -helptext "TkAntivir Einstellungen"
button .icon.button3b -text "Einstellungen" -command do_preferences -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imaged}
image create bitmap imaged -file $path_to_tkantivir/i.xbm
Button .icon.button4 -image imaged -text "ber..." -command do_vdfinfo -relief flat -background white -highlightbackground white
button .icon.button4b -text "AntiVir- und\nVDF-Infos" -command do_vdfinfo -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
label .icon.rest -text " \n " -bg white
pack .icon.button1 .icon.button1b .icon.buttont .icon.buttontb .icon.button2 .icon.button2b .icon.button3 \
.icon.button3b .icon.button4 .icon.button4b .icon.rest
} else {
frame .icon -relief sunken -bd 2 -background white -highlightbackground white
catch {image delete imagea}
image create photo imagea -file $path_to_tkantivir/find.gif
Button .icon.button1 -text "Suchen" -command do_find -relief link -image imagea -helptext "Suchen" -background white -highlightbackground white
button .icon.button1b -text "Suchen" -command do_find -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imaget}
image create photo imaget -file $path_to_tkantivir/clock.gif
Button .icon.buttont -text "Scheduler" -relief link -image imaget -command do_sched -helptext "Scheduler starten" -background white -highlightbackground white
button .icon.buttontb -text "Scheduler" -command do_sched -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imageb}
image create photo imageb -file $path_to_tkantivir/text.gif
Button .icon.button2 -text "Report-Viewer" -image imageb -command do_report -relief link -helptext "Report-Viewer starten" -background white -highlightbackground white
button .icon.button2b -text "Report-Viewer" -command do_report -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imagec}
image create photo imagec -file $path_to_tkantivir/pref.gif
Button .icon.button3 -image imagec -text "Einstellungen" -command do_preferences -relief link -helptext "TkAntivir Einstellungen" -background white -highlightbackground white
button .icon.button3b -text "Einstellungen" -command do_preferences -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
catch {image delete imaged}
image create photo imaged -file $path_to_tkantivir/i.gif
Button .icon.button4 -text "ber..." -image imaged -command do_vdfinfo -relief link -helptext "VDF-/AntiVir-Informationen" -background white -highlightbackground white
button .icon.button4b -text "AntiVir- und\nVDF-Infos" -command do_vdfinfo -relief flat -background white -highlightbackground white \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
label .icon.rest -text " \n " -bg white
pack .icon.button1 .icon.button1b .icon.buttont .icon.buttontb .icon.button2 .icon.button2b .icon.button3 .icon.button3b .icon.button4 .icon.button4b .icon.rest

}

# Graue Titelueberschrift
frame .label -relief flat -bg gray68
label .label.title -text " AntiVir-Such- und Reparatureinstellungen" -bg gray68 \
                   -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*
pack .label.title -side left

# ###################################################################
# Elemente der linken Seite

NoteBook .chooser

set ondem [.chooser insert 1 ondemand -text "Such- und Reparatureinstellungen" -activebackground gray85]

frame $ondem.oben
frame $ondem.unten
frame $ondem.mitte
frame $ondem.rechts
frame $ondem.nochrechter


TitleFrame $ondem.scan -relief groove -text "Sucheinstellungen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

set subf [$ondem.scan getframe]

radiobutton $subf.subdir -text "auch Unterverzeichnisse" \
                         -variable sub_dir \
                         -value 1 \
                         -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

radiobutton $subf.cur -text "nur aktuelles Verzeichnis" \
                      -variable sub_dir \
                      -value 0 \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

frame $subf.path

label $subf.path.l -text "Pfad " \
                   -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                   
entry $subf.path.e -width 18 \
                   -relief sunken \
            			    -bd 2 \
            			    -textvariable path_to_search \
            			    -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                         
pack $subf.path.l $subf.path.e -side left

checkbutton $subf.defs -text "nur diese Dateitypen" \
                       -variable option_nodef \
                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                       
frame $subf.defw

label $subf.defw.l -text "Typen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

entry $subf.defw.e -width 17 -relief sunken -bd 2 \
            			    -textvariable file_defs \
            			    -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf.defw.l $subf.defw.e -side left

#checkbutton $subf.trjoke -text "Scherzviren etc. ignorieren" \
#                         -variable option_trjoke \
 #                       -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
 
#label $subf.blank -text " " -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf.path $subf.subdir $subf.cur $subf.defs $subf.defw  -anchor nw


# Default auf "auch Unterverzeichnisse"
set sub_dir 1

# ###################################################################
# Elemente fuer Frame rechts
TitleFrame $ondem.av_options -relief groove -text "Optionen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

set subf [$ondem.av_options getframe]

checkbutton $subf.dialer -text "nach Dialern, Spielen, Joke-  \nViren und PMS suchen          " \
-variable option_trjoke \
                         -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

checkbutton $subf.nolnk -text "keinen symbol. Links folgen" \
                        -variable option_nolnk \
                        -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                                  
checkbutton $subf.wholefile -text "ganze Datei durchsuchen" \
                            -variable option_wholefile \
                            -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

checkbutton $subf.lzexe -text "kein Scan von PKLite-Dateien" \
                        -variable option_lzexe \
                        -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

checkbutton $subf.zip -text "Archivdateien durchsuchen" \
                      -variable option_zip \
                      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf.dialer $subf.nolnk $subf.wholefile $subf.lzexe $subf.zip -anchor nw

# ###################################################################
# Elemente fuer 2x Frame unten (fuer [Makro-]Reparaturoptionen)
TitleFrame $ondem.rep -relief groove -text "Reparatureinstellungen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

set subf [$ondem.rep getframe]

label $subf.titel -text "Reparatureinstellungen" \
		            -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

radiobutton $subf.repcontrol -text "ignorieren" \
                             -variable option_rep \
                             -value none \
                             -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                             
radiobutton $subf.repinf -text "infizierte Datei reparieren" \
                         -variable option_rep \
                         -value rep \
                         -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                         
radiobutton $subf.repren -text "Datei umbenennen\n(*.COM -> *.VOM)" \
                         -variable option_rep \
           		            -value ren \
		                   -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                         
radiobutton $subf.reploe -text "infizierte Datei lschen" \
                         -variable option_rep \
           		            -value loe \
           		            -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

#radiobutton $subf.movs -text "Datei verschieben" \
#                       -variable option_rep \
#                       -value move \
#                        -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

#frame $subf.movw

#label $subf.movw.l -text "Ziel" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

#entry $subf.movw.e -width 19 \
#                   -relief sunken \
#            			    -bd 2 \
#            			    -textvariable moveto \
#			          -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

#pack $subf.movw.l $subf.movw.e -side left

pack $subf.repcontrol $subf.repinf $subf.repren $subf.reploe -anchor nw

# Default auf "ignorieren"
set option_rep none

TitleFrame $ondem.macro -relief groove -text "Makro-Reparatureinstellungen" -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

set subf [$ondem.macro getframe]

radiobutton $subf.ignore -text "ignorieren" \
                         -variable option_mac \
                         -value none \
                         -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                         
radiobutton $subf.delf -text "Word-Dokument m. verdch- \ntigem Makro lschen             " \
                       -variable option_mac \
                       -value delf \
         		            -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                           
radiobutton $subf.delm -text "verdchtige Makros lschen" \
                       -variable option_mac \
         		            -value delm \
		                 -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
                       
radiobutton $subf.delam -text "alle Makros lschen" \
                        -variable option_mac \
          		            -value delam \
		                  -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

pack $subf.ignore $subf.delf $subf.delm $subf.delam -anchor nw

#label	$ondem.tkant	-text "  TkAntivir 1.51.01\n    Tcl/Tk-Frontend fr AntiVir/X" \
#             -foreground gray50 \
#		       -font -*-Helvetica-Bold-R-Normal--*-120-*-*-*-*-*-*

# Default auf "ignorieren"
set option_mac none

set report [.chooser insert 2 avproto -text "AntiVir Report" -activebackground gray85]

frame $report.oben
frame $report.unten
frame $report.mitte
frame $report.rechts
frame $report.nochrechter

frame $report.output

text $report.output.text -relief sunken -bd 2 \
                         -yscrollcommand "$report.output.scroll set" -bg white \
                 		      -font *-Courier-Medium-R-Normal--*-120-*-*-*-*-*-* -width 55 -height 24
scrollbar $report.output.scroll -command "$report.output.text yview"

pack $report.output $report.output.text $report.output.scroll -anchor n -fill y -side left

# ###################################################################
# Elemente fuer Statuszeile
frame .statusBar
label .statusBar.big -text " " -relief sunken -bd 1 \
                     -font -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-* -anchor w
label .statusBar.small -textvariable currenttime -width 8 -relief sunken -bd 1 \
                       -font -*-Helvetica-Medium-R-Normal--*-100-*-*-*-*-*-* -anchor center
pack .statusBar.big -side left -padx 2 -expand yes -fill both
pack .statusBar.small -side left -padx 2

# ###################################################################
# jetzt den Layoutmananger anwerfen
wm title . "TkAntivir"
wm geometry . +220+120
wm resizable . 1 1
pack .menu -fill x

pack .icon -in .links -anchor n -pady 1.7m -padx 2m -ipady 1m

# Kurztasten einbinden
bind . <Meta-x> {exit}
bind . <F1> {do_about}
bind . <F2> {do_find}
bind . <F9> {do_preferences}

pack .links -anchor n -side left
pack .mitte
pack .unten -fill x -expand yes

pack $ondem.oben
pack $ondem.unten
pack $ondem.mitte
pack $ondem.rechts $ondem.nochrechter -side left -in $ondem.mitte -anchor nw

pack $ondem.scan -in $ondem.rechts -fill x -padx 3m -ipady 2.3m -pady 2m
pack $ondem.av_options -anchor nw -in $ondem.nochrechter -fill y -padx 2m -pady 2m
pack $ondem.rep -anchor nw -in $ondem.rechts -fill y -padx 3m -pady 2m
pack $ondem.macro -anchor nw -in $ondem.nochrechter -fill y -padx 1.7m -pady 2m
#pack $ondem.tkant -anchor nw -in $ondem.nochrechter -fill y -padx 2m -pady 2m

pack $report.oben
pack $report.unten
pack $report.mitte
pack $report.rechts $report.nochrechter -side left -in $report.mitte -anchor nw
pack $report.output -in $report.mitte -fill y

.chooser compute_size
pack .chooser -anchor n -fill x -in .unten -pady 2m -padx 2m
.chooser raise ondemand
pack .statusBar -side top -fill both -pady 2 -expand yes -in .unten

# ##################################################################
# Auf Vorhandensein der Konf.datei pruefen und bei unvollst. Ein-
# stellungen ggf. Voreinstellungsfenster laden!

wm iconify .

after 3000 {
   
   update idletask
   destroy .wina
   wm deiconify .
   .statusBar.big config -text "AntiVir-VDF-Version: $vdf_ver"
   update idletask
   after 2500 {.statusBar.big config -text "TkAntivir-Profil-Datei: nicht geladen"
      update idletask

      if [ expr $argc != 0 ] {
         set arg1 [lindex $argv 0]
         switch -exact -- $arg1 {
	         "-profile" {
            set argv [ lrange $argv 1 end]
        	   set scpfile $argv
           do_kdeprofload
           do_find
           }
         }
     }

   }

}

update_time

if {[file exists "$path_to_antivir/hbedv.key"] == 0 && [file exists "$path_to_antivir/HBEDV.KEY"] == 0} {
   catch { destroy .winl }
   toplevel .winl -class Dialog
   wm title .winl "TkAntivir"
   wm geometry .winl +300+300
   message .winl.warn -justify left \
                      -width 350 \
                      -text "\n\n \
			    Es ist keine AntiVir-Lizenz-Datei vorhanden.\n \
			    AntiVir luft deshalb im Demo-Modus.\n" \
		      -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*

   label .winl.icon -bitmap warning
   button .winl.ok -text "OK" -command "set buttonpressed 1" \
                  -font -*-Helvetica-Medium-R-Normal--*-120-*-*-*-*-*-*
   pack .winl.icon -in .winl -padx 3m -pady 3m -side left
   pack .winl.warn .winl.icon .winl.ok
   tkwait variable buttonpressed
   destroy .winl

   set sub_dir 0
   set subf [$ondem.scan getframe]
   $subf.subdir configure -state disabled
   $subf.cur configure -state disabled
   
    
   set subf [$ondem.rep getframe]
   $subf.repcontrol configure -state disabled
   $subf.repinf configure -state disabled
   $subf.repren configure -state disabled
   $subf.reploe configure -state disabled
   $subf.movs configure -state disabled
   $subf.movw.l configure -state disabled
   $subf.movw.e configure -state disabled
    
   set subf [$ondem.macro getframe]
   $subf.ignore configure -state disabled
   $subf.delf configure -state disabled
   $subf.delm configure -state disabled
   $subf.delam configure -state disabled

   set subf [$ondem.av_options getframe]
   $subf.nolnk configure -state disabled
   set option_nolnk 0
}
